	.include "tiams.inc"
	.text
	.align	2
Frame:
	.long	0xff000000
	.long	0x0
	.word	0x3
	.long	0x1
	.long	0xA

	.long	0x1
	.long	0x1
	.long	0x2
	.long	Name
	.long	0x3
	.long	Name 
	.long	0x4
	.long	Event
	.long	0x5
	.long	GamesMenu
	.long	0x7
	.long	0x1
	.long	0x8
	.long	EExts
	.long	0x9
	.long	EEntries
	.long	0x1000
	.long	OXOName
	.long	0x1001
	.long	OXOHelp

EExts:
	.long	0x1000
	.long	0x1001
	.word	0x0

EEntries:
	.long	OXO
	.word	0x0

Name:
	.byte	"Games\0"

Event:
	move.l	(#8,sp),a0
	cmp.w	#$702,(a0)
	beq		Start
	cmp.w	#$703,(a0)
	beq		Activate
	cmp.w	#$706,(a0)
	beq		Deactivate
	cmp.w	#$707,(a0)
	beq		Quit
	cmp.w	#$710,(a0)
	beq		KeyPress
	cmp.w	#$70C,(a0)
	beq		RestoreDefaults
	cmp.w	#$782,(a0)
	beq		RestoreDefaults
	cmp.w	#$774,(a0)
	beq		About
	cmp.w	#$500,(a0)
	beq		About
	cmp.w	#$501,(a0)
	beq		StartOXO
DefaultHandler:
	move.l	a0,-(sp)
	.word	$F800+EV_defaultHandler/4
	addq.l	#4,sp
	rts
Start:
	move.w	#$60,-(sp)
	move.l	(#8,a0),a1
	pea		(a1)
	pea		Window
	.word	$F800+WinOpen/4
	lea		10(sp),sp
	tst.b	d0
	bne		NoExit
	.word	$F800+EV_quit/4
NoExit:
	rts
Activate:
	move.l	a0,-(sp)
	pea		Window
	.word	$F800+WinActivate/4
	.word	$F800+WinBeginPaint/4
	.word	$F800+WinClr/4
	move.l	#WindowText,(sp)
	pea		Window
	.word	$F800+WinStr/4
	addq.l	#8,sp
	move.l	(sp)+,a0
	bra		DefaultHandler
Deactivate:
	move.l	a0,-(sp)
	pea		Window
	.word	$F800+WinDeactivate/4
	.word	$F800+WinEndPaint/4
	addq.l	#4,sp
	move.l	(sp)+,a0
	bra		DefaultHandler
KeyPress:
	cmp.w	#$0D,(#10,a0)
	bne		DefaultHandler
StartLastGame:
	tst.l	LastGame
	beq		DefaultHandler
	move.l	LastGame,a0
	jmp		(a0)
Quit:
	pea		Window
	.word	$F800+WinClose/4
	addq.l	#4,sp
	rts
RestoreDefaults:
	clr.l	LastGame
	clr.w	OXOSavedGame
	rts
About:
	clr.l	-(sp)
	clr.l	-(sp)
	move.w	#-1,-(sp)
	move.w	#-1,-(sp)
	pea		AboutBox
	.word	$F800+Dialog/4
	lea		16(sp),sp
	rts
StartOXO:
	move.l	#OXO,LastGame
	bra		StartLastGame
	rts

	.comm	Window,76,2
	.comm	LastGame,4,2

	.data
	.align	2
PFrame:
	.long	Frame

	.section	.const
	.align	2
GamesMenu:	
	.word	GameTitle-GamesMenu
	.word	16390
	.word	1
	.byte	240,18
	.word	2
	.word 	0
	.word 	0,0
	.long 	0xFFFFFFFF
	.word	0xCFFF
	.word	GameTitle-GameTitle
	.word 	GamesSubMenu - GamesMenu
	.word 	0x8500
	.word	AboutTitle-GameTitle
	.long 	0xFFFFFFFF
GamesSubMenu:
	.word	0x8501
	.word	GameOXO-GameTitle
	.long	0xFFFFFFFF
GameTitle:
	.byte	"Games\0"
GameOXO:
	.byte	"OXO\0"
AboutTitle:
	.byte	"About\0"

AboutBox:
	.word	AboutBoxTitle-AboutBox
	.word	9
	.byte	0
	.byte	0
	.long	DummyCallBack

	;Header
	.byte	8,128,0,0
	.word	AboutBoxTitle-AboutBoxTitle
	.byte	0,0
	.byte	0,0,0,0

	;Thanks to
	.byte	7,0,0,12
	.word	AboutBoxThanksTo-AboutBoxTitle
	.byte	0,0,0,0,0,0

	;TI
	.byte	7,0,4,20
	.word	AboutBoxThanksToTI-AboutBoxTitle
	.byte	0,0,0,0,0,0

	;Jonas Lf
	.byte	7,0,4,28
	.word	AboutBoxThanksToJonasLoof-AboutBoxTitle
	.byte	0,0,0,0,0,0
 
	;Requirements 0
	.byte	7,0,0,38
	.word	AboutBoxRequirements0-AboutBoxTitle
	.byte	0,0,0,0,0,0

	;Requirements 1
	.byte	7,0,0,46
	.word	AboutBoxRequirements1-AboutBoxTitle
	.byte	0,0,0,0,0,0

	;Requirements 2
	.byte	7,0,0,54
	.word	AboutBoxRequirements2-AboutBoxTitle
	.byte	0,0,0,0,0,0

	;Contact
	.byte	7,0,0,64
	.word	AboutBoxContact-AboutBoxTitle
	.byte	0,0,0,0,0,0

	;License
	.byte	7,0,0,74
	.word	AboutBoxLicense-AboutBoxTitle
	.byte	0,0,0,0,0,0

	;End
	.byte	0,0

AboutBoxTitle:
	.byte	"About Games\0"
AboutBoxThanksTo:
	.byte	"Thanks to:\0\0"
AboutBoxThanksToTI:
	.byte	"- Texas Instrument (for TI FLASH Studio)\0\0"
AboutBoxThanksToJonasLoof:
	.byte	"- Jonas Lf (method for better greyscales)\0"
AboutBoxRequirements0:
	.byte	"This application is designed to run on a\0\0"
AboutBoxRequirements1:
	.byte	"TI-89 (HW 1) with AMS 2.05 or higher\0\0"
AboutBoxRequirements2:
	.byte	"(Other configurations may work too)\0"
AboutBoxContact:
	.byte	"My e-mail: johan.deprez@advalvas.be\0"
AboutBoxLicense:
	.byte	"Released under the GNU GPL (www.gnu.org)\0\0"

DummyCallBack:
	move.l	#$FFFC,d0
	rts

WindowText:
	.byte	"Please select a game from the \"Games\" menu or press <enter> to start the last selected game.\0"